################################################################################
# #ID_Number=81178
# System:  "2C42-65"
# Machine: "ATPU-125"
# Type: LATHE
# version xx.xx.xx (12/12/2001)
# Russia, KnAAPO,OGT,SPC(Sector of the Program Control,#"  ")
# Author's : Rodionova Elena.
#
################################################################################
#   	Date        		Who           		Reason#
# 10-11 --2002   Rodionova            0. Original
# 15.02.2002 9:38       Rodionova            1.    ( G09,     )
#                                                       USER DEFINED  SLOWDN/angle[,maxfeed]
# 05.03/2002   		Rodionova            1.   'Zero'
# 10.03.2002            Rodionova            1.    
#                                                 2.    .   mom_kin_min_arc_length
# $HISTORY$
################################################################################
# ------------------------------------- VARIABLES  --------------------------------------------
#
 set Afaska            0.0
 set fl_drobl   	0
#
global circleNumber 	      ; set circleNumber 0	    ; #       (   )
global var_start_of_path_num  ; set var_start_of_path_num 0 ; #   
global output_help            ; set output_help  "OFF"	    ; # OFF -  , ON - 
global mom_time		      ; set mom_time   OFF  	    ; #  
global first_tool 	      ; set first_tool 0	    ; #  1- 
global mom_rewind_end_of_program ; set mom_rewind_end_of_program     0 ; #   M02|M30
#
global subprogram_text        ; set subprogram_text              "" ;
global def_subprogram_code    ; set def_subprogram_code           0 ;
global start_subprogram_code  ; set start_subprogram_code         0 ;
global number_subprogram      ; set number_subprogram             0 ; #  
global flag_subprogram        ; set flag_subprogram               0 ;
global stloop_text            ; set stloop_text                  "" ;
global stloop_code            ; set stloop_code                   0 ;
#
set mom_rapid_distantion_const 40.0
set mom_rapid_distantion_flag  ON
#   
 global   SLOWDN_MIN_ANGLE  SLOWDN_MAX_FEED  SLOWDN_ACCELERATION
 global   mom_modes_slowdn
 global   mom_slowdn_min_angle
  set SLOWDN_MIN_ANGLE     "3.0"
  set SLOWDN_MAX_FEED      "600.0"
  set SLOWDN_ACCELERATION  "5"
#    ( )
  set mom_modes_slowdn       "AUTO"  ;
  set mom_slowdn_min_angle $SLOWDN_MIN_ANGLE;
################################################################################

  set cam_post_dir  [MOM_ask_env_var UGII_CAM_POST_DIR]
  set cam_debug_dir [MOM_ask_env_var UGII_CAM_DEBUG_DIR]

#proc MOM_before_each_add_var {} {}
#proc MOM_before_each_event {} {}
# source ${cam_debug_dir}mom_review.tcl ; MOM_set_debug_mode ON
#source [MOM_ask_env_var UGII_CAM_DEBUG_DIR]mom_debug.tcl
#source [MOM_ask_env_var UGII_CAM_DEBUG_DIR]mom_review.tcl ; MOM_set_debug_mode ON

################################################################################
#The following command invokes the warning mode and the default settings.
source [MOM_ask_env_var UGII_CAM_POST_DIR]/ugpost_base.tcl
#source ${cam_post_dir}/ugpost_base.tcl

########################## SYSTEM VARIABLE DECLARATIONS #########################
  set mom_sys_rapid_code                      "0"
  set mom_sys_linear_code                     "1"
  set mom_sys_circle_code(CLW)                "2"
  set mom_sys_circle_code(CCLW)               "3"
  set mom_sys_lathe_thread_advance_type(1)    "33"
  set mom_sys_cycle_tap_code                  "33"
  set mom_sys_delay_code(SECONDS)             "4"
  set mom_sys_delay_code(REVOLUTIONS)	      "4"
#
  set mom_sys_delay_code(SLOWDN)              "9"
  set mom_sys_delay_code(CHECK)               "5"
  set mom_sys_delay_code(DROBL)               "99"
#
  set mom_sys_cutcom_code(OFF)               "40"
  set mom_sys_cutcom_code(ON)                "63"
  set mom_sys_cutcom_code(LEFT)              "63"
  set mom_sys_cutcom_code(RIGHT)             "63"
#
  set mom_sys_cycle_breakchip_code              "73"
  set mom_sys_cycle_bore_no_drag_code           "76"
  set mom_sys_cycle_drill_code                  "81"
  set mom_sys_cycle_drill_deep_code             "9"
  set mom_sys_cycle_tap_code                    "33"
  set mom_sys_cycle_bore_code                   "85"
  set mom_sys_cycle_bore_drag_code              "86"
  set mom_sys_cycle_bore_back_code              "87"
#
  set mom_sys_output_code(ABSOLUTE)            "90"
  set mom_sys_output_code(INCREMENTAL)         "91"
  set mom_sys_reset_code                       "92"
  set mom_sys_feed_rate_mode_code(MMPM)        "94"
  set mom_sys_feed_rate_mode_code(MMPR)        "95"
  set mom_sys_return_code                      "25"
#
  set mom_sys_program_stop_code                 "0"
  set mom_sys_optional_stop_code                "1"
  set mom_sys_end_of_program_code               "2"
  set mom_sys_spindle_direction_code(CLW)       "3"
  set mom_sys_spindle_direction_code(CCLW)      "4"
  set mom_sys_spindle_direction_code(OFF)       "5"
  set mom_sys_spindle_direction_code(ORIENT)	"19"
  set mom_sys_tool_change_code                  "6"
  set mom_sys_coolant_code(MIST)                "8"
  set mom_sys_coolant_code(ON)                  "8"
  set mom_sys_coolant_code(FLOOD)               "8"
  set mom_sys_coolant_code(OFF)                 "9"
  set mom_sys_rewind_code                       "30"
#
  set mom_sys_spindle_ranges                    "2"
  set mom_sys_spindle_range_code(1)             "41"
  set mom_sys_spindle_range_code(2)             "42"
  set mom_sys_spindle_range_code(41)            "41"
  set mom_sys_spindle_range_code(42)            "42"
	set mom_sys_spindle_param(1,min)        "224"
	set mom_sys_spindle_param(1,max)        "3000"
	set mom_sys_spindle_param(2,min)        "50"
	set mom_sys_spindle_param(2,max)        "693"
#
set mom_sys_end_of_subprogram_code              "17"
#
  set mom_sys_rewind_stop_code                  "%"
  set mom_sys_home_pos(0)                       "0"
  set mom_sys_home_pos(1)                       "0"
  set mom_sys_home_pos(2)                       "0"
  set mom_sys_zero                              "0"
  set mom_sys_opskip_block_leader               "/"
  set mom_sys_seqnum_start                      "1"
  set mom_sys_seqnum_incr                       "1"
  set mom_sys_seqnum_freq                       "1"
  set mom_sys_leader(N)                         "N"
  set mom_sys_contour_feed_mode(LINEAR)         "MMPM"
  set mom_sys_contour_feed_mode(ROTARY)         "MMPM"
  set mom_sys_contour_feed_mode(LINEAR_ROTARY)  "MMPM"
  set mom_sys_rapid_feed_mode(LINEAR)           "MMPM"
  set mom_sys_rapid_feed_mode(ROTARY)           "MMPM"
  set mom_sys_rapid_feed_mode(LINEAR_ROTARY)    "MMPM"
  set mom_sys_feed_param(IPM,format)            "Feed_IPM"
  set mom_sys_feed_param(FRN,format)            "Feed_INV"
  set mom_sys_feed_param(DPM,format)            "Feed_DPM"
  set mom_sys_feed_param(MMPM,format)           "Feed_MMPM"
  set mom_sys_feed_param(MMPR,format)           "Feed_MMPR"
  set mom_sys_cycle_feed_mode                   "MMPM"
  set mom_sys_control_out                       "("
  set mom_sys_control_in                        ")"
  set mom_sys_lathe_x_factor                    "2"
  set mom_sys_lathe_z_factor                    "1"
  set mom_sys_delay_output_mode                 "SECONDS"
  set mom_sys_delay_param(SECONDS,format)       "Dwell_SECONDS"
  set mom_sys_delay_param(REVOLUTIONS,format)   "Dwell_REVOLUTIONS"

####### KINEMATIC VARIABLE DECLARATIONS ############

  set mom_kin_arc_output_mode                   "QUADRANT" ; # FULL_CIRCLE  LINEAR QUADRANT
  set mom_kin_arc_valid_planes                  "XZ" ; #  XYZ  ANY
  set mom_kin_clamp_time                        "2.0"
  set mom_kin_dependent_head                    "NONE"
  set mom_kin_independent_head 			"NONE"
  set mom_kin_ind_to_dependent_head_x           "-7.0"
  set mom_kin_ind_to_dependent_head_z           "-10.0"
  set mom_kin_linearization_flag                "F"
  set mom_kin_linearization_tol                 "0.001"
  set mom_kin_machine_resolution                "0.001"
  set mom_kin_machine_type                      "lathe"
  set mom_kin_max_arc_radius                    "9999.999"
  set mom_kin_max_dpm                           "100"
  set mom_kin_max_fpm                           "7000.0"
  set mom_kin_max_fpr                           "7000.0"
  set mom_kin_max_frn                           "3000"
  set mom_kin_min_arc_length                    "0.025"
  set mom_kin_min_arc_radius                    "0.016"
  set mom_kin_min_dpm                           "0.0"
  set mom_kin_min_fpm                           "0.0"
  set mom_kin_min_fpr                           "0.0"
  set mom_kin_min_frn                           "0.0"
  set mom_kin_output_unit                       "MM"
  set mom_kin_pivot_gauge_offset                "0.0"
  set mom_kin_post_data_unit                    "MM"
  set mom_kin_rapid_feed_rate                   "7000.0" ;# "9999.999"
  set mom_kin_tool_change_time                  "12.0"
  set mom_kin_x_axis_limit                      "280"
  set mom_kin_y_axis_limit                      "0"
  set mom_kin_z_axis_limit                      "300"
  set mom_kin_read_ahead_next_motion            "true"

####  Listing File variables
  set mom_sys_list_output                       "ON"
  set mom_sys_header_output                     "ON"
  set mom_sys_list_file_rows                    "999"
  set mom_sys_list_file_columns                 "80"
  set mom_sys_warning_output                    "ON"
  set mom_sys_group_output                      "OFF"
  set mom_sys_list_file_suffix                  "lpt"
  set mom_sys_output_file_suffix                "up"
  set mom_sys_commentary_output                 "ON"
  set mom_sys_commentary_list                   "x y z feed speed"

#=============================================================
proc MOM_start_of_program { } {
#=============================================================
   global mom_logname mom_date is_from
  global mom_coolant_status mom_cutcom_status
  global mom_clamp_status mom_cycle_status
  global mom_spindle_status mom_cutcom_plane pb_start_of_program_flag
  global mom_cutcom_adjust_register mom_tool_adjust_register
  global mom_tool_length_adjust_register mom_length_comp_register
  global mom_flush_register mom_wire_cutcom_adjust_register

    set pb_start_of_program_flag 0
    set mom_coolant_status UNDEFINED
    set mom_cutcom_status  UNDEFINED
    set mom_clamp_status   UNDEFINED
    set mom_cycle_status   UNDEFINED
    set mom_spindle_status UNDEFINED
    set mom_cutcom_plane   UNDEFINED

  catch {unset mom_coolant_mode}
  catch {unset mom_coolant_status}
  catch {unset mom_cutcom_mode}
  catch {unset mom_cutcom_status}

    catch {unset mom_cutcom_adjust_register}
    catch {unset mom_tool_adjust_register}
    catch {unset mom_tool_length_adjust_register}
    catch {unset mom_length_comp_register}
    catch {unset mom_flush_register}
    catch {unset mom_wire_cutcom_adjust_register}

    set is_from ""

    OPEN_files ; #open warning and listing files
    LIST_FILE_HEADER ; #list header in commentary listing

}


#=============================================================
proc PB_start_of_program { } {
#=============================================================
global  mom_warning_info
global  mom_output_file_basename
global  mom_logname  mom_date

   if { [llength [info commands PB_CMD_kin_start_of_program]] } {
      PB_CMD_kin_start_of_program
   }

  set mom_warning_info "\n   242-65 ( ) ( ISO)."
  MOM_output_to_listing_device $mom_warning_info  ;  # MOM_catch_warning ;

  set mom_warning_info "\n :\n"
  append mom_warning_info "\tG00 -  \n"
  append mom_warning_info "\tG23 -     \n"
  append mom_warning_info "\tG40 -       \n"
  append mom_warning_info "\tG90 -  \n"
  append mom_warning_info "\tG94 -   / \n"
  MOM_output_to_listing_device $mom_warning_info  ; #  MOM_catch_warning ;

 global output_help ;
 if {[info exists output_help]==0} { set output_help "ON" }
 if {$output_help =="ON"} {
 ;#      ( )
  global mom_update_post_cmds_from_tool
  if {[info exists mom_update_post_cmds_from_tool]} {
  	set mom_warning_info "\n  mom_update_post_cmds_from_tool=$mom_update_post_cmds_from_tool\n"
  	append mom_warning_info "\t=>\n"
    switch $mom_update_post_cmds_from_tool {
    0 { append mom_warning_info "\t1)           'Tool Change'\n"
        append mom_warning_info "\t2)  ,    (),   -     'Spindle On/Off'\n"
        append mom_warning_info "\n\t ! ,        ,\n"
        append mom_warning_info "\t     '' -   'Manufacturing Preferences'-> 'Operation'\n"
        append mom_warning_info "\t    'Update Post From Tool'.\n"
      }
     default {
        append mom_warning_info "\t1)     ,     (  ) -  ,    \n"
        append mom_warning_info "\t2)   ,   -     'Spindle On/Off'\n"
        append mom_warning_info "\n\t ! ,          ,\n"
        append mom_warning_info "\t     '' -   'Manufacturing Preferences'-> 'Operation'\n"
        append mom_warning_info "\t    'Update Post From Tool'.\n"
       }
     }
     MOM_output_to_listing_device $mom_warning_info  ; # MOM_catch_warning ;
   }

 }

  global mom_sys_rewind_stop_code
  set str "$mom_sys_rewind_stop_code"

  global partno_program
  if {[info exists partno_program]} {
    if {$partno_program != ""} { append str $partno_program }
   }

   MOM_set_seq_off
   MOM_output_literal "$str" ;# "%81178"
   MOM_set_seq_on

   MOM_force Once G_mode
   MOM_suppress once G_drobl U V ;

#   
 global   SLOWDN_MIN_ANGLE
 global   mom_modes_slowdn
 global   mom_slowdn_min_angle
#    ( )
  set mom_slowdn_min_angle $SLOWDN_MIN_ANGLE;
  global mom_user_defined_text mom_record_fields ;
  set mom_record_fields(0) SLOWDN ;
  set mom_record_fields(1) $mom_modes_slowdn ;
  MOM_text ;

}

#=============================================================
proc PB_CMD_machine_mode { } {
#=============================================================
  global mom_output_mode mom_arc_mode mom_prev_machine_mode mom_machine_mode mom_feed_set_mode
  set mom_output_mode     	"ABSOLUTE"
  set mom_prev_machine_mode  	"LATHE"
  set mom_machine_mode 		"LATHE" ;
  set mom_arc_mode     		"CIRCULAR" ;
  set mom_feed_set_mode 	"MMPM" ;
}

#=============================================================
proc MOM_machine_mode {} {
#=============================================================
  catch {PB_CMD_machine_mode} errMes ; MOM_log_message "$errMes" ;
}


#=============================================================
proc MOM_msys {} {
#=============================================================
# This procedure is called for a MSYS statement
}


############## EVENT HANDLING SECTION ################

#=============================================================
proc MOM_start_of_path { } {
#=============================================================
  global mom_path_name mom_tool_name

  global pb_start_of_program_flag
  if {$pb_start_of_program_flag == 0} {
      PB_start_of_program ;
      MOM_force once S M_spindle X Y Z F
      set pb_start_of_program_flag 1
    }

  CHECK_OPER_TYPE
  TOOL_SET MOM_start_of_path

  global circleNumber ; set circleNumber 0; #       (   )
  global  var_start_of_path_num ;incr var_start_of_path_num ; #   

}


#=============================================================
proc  MOM_before_motion { } {
#=============================================================
  global mom_motion_event mom_motion_type
  global mom_pos mom_prev_pos
  global mom_ref_pos mom_ref_pos_arc_center  mom_pos_arc_center
  global mom_gohome_ref_pos mom_gohome_pos mom_from_ref_pos
  global feed

    FEEDRATE_SET
    set mom_pos(0) $mom_ref_pos(0)
    set mom_pos(1) $mom_ref_pos(1)
    set mom_pos(2) $mom_ref_pos(2)

    switch $mom_motion_event {
      circular_move {
        if {[hiset mom_ref_pos_arc_center(0)]} {set mom_pos_arc_center(0) $mom_ref_pos_arc_center(0)}
        if {[hiset mom_ref_pos_arc_center(1)]} {set mom_pos_arc_center(1) $mom_ref_pos_arc_center(1)}
        if {[hiset mom_ref_pos_arc_center(2)]} {set mom_pos_arc_center(2) $mom_ref_pos_arc_center(2)}
      }
      from_move {
        if {[hiset mom_from_ref_pos(0)]} {set mom_from_pos(0) $mom_from_ref_pos(0)}
        if {[hiset mom_from_ref_pos(1)]} {set mom_from_pos(1) $mom_from_ref_pos(1)}
        if {[hiset mom_from_ref_pos(2)]} {set mom_from_pos(2) $mom_from_ref_pos(2)}
      }
      gohome_move {
        if {[hiset mom_gohome_ref_pos(0)]} {set mom_gohome_pos(0) $mom_gohome_ref_pos(0)}
        if {[hiset mom_gohome_ref_pos(1)]} {set mom_gohome_pos(1) $mom_gohome_ref_pos(1)}
        if {[hiset mom_gohome_ref_pos(2)]} {set mom_gohome_pos(2) $mom_gohome_ref_pos(2)}
      }
    }

    switch $mom_motion_type {
      ENGAGE { ; }
      APPROACH { ; }
      FIRSTCUT { ; }
    }

}


#=============================================================
proc MOM_from_move { } {
#=============================================================
  global mom_ref_pos mom_gohome_ref_pos
  catch { COOLANT_SET ; CUTCOM_SET ; SPINDLE_SET ; RAPID_SET ;  MODES_SET ; }  errMes ; MOM_log_message "$errMes" ;
  global From_pos
    set From_pos(0) $mom_ref_pos(0)
    set From_pos(2) $mom_ref_pos(2)
 catch { MOM_do_template from CREATE } errMes ; MOM_log_message "$errMes" ;
}


#=============================================================
proc MOM_initial_move { } {
# This procedure is executed for the initial move of each operation.  It
# assumes the tool is moving from a safe position at rapid to the start of the operation.
#=============================================================
 global mom_motion_event mom_motion_type
 global  mom_feed_rate  mom_kin_rapid_feed_rate
 global  mom_programmed_feed_rate
 global  feed

 catch { COOLANT_SET ; CUTCOM_SET ; SPINDLE_SET ; RAPID_SET ; MODES_SET ; } errMes ; MOM_log_message  "$errMes"

 MOM_force once  X Z

#  if {[info exists mom_kin_rapid_feed_rate]} {
#    if { ($mom_programmed_feed_rate !=0) && ($mom_feed_rate < $mom_kin_rapid_feed_rate) } { MOM_linear_move; return  }
#   }

 if {"$mom_motion_event" == "rapid_move"} { MOM_rapid_move ; return  }
 if {"$mom_motion_type" == "RAPID"} {  MOM_rapid_move ; return }

	MOM_linear_move

}


#=============================================================
proc MOM_linear_move { } {
#=============================================================
# This procedure is executed for each linear move. It gets called after
# the positioning varables, position and tool axis (X,Y,Z,TAX,TAY,TAZ) are loaded.
   global mom_motion_event  mom_motion_type

# 1)
   if {$mom_motion_event == "rapid_move"} {  MOM_rapid_move ;   return ;  }

# 2)
  global mom_cutcom_mode  mom_cutcom_status
  if {[info exists mom_cutcom_mode]} {  set mom_cutcom_status $mom_cutcom_mode ; }

# 4)
  global  mom_spindle_speed  mom_spindle_mode mom_spindle_status
  if {[info exists mom_spindle_speed]} {
    if {$mom_spindle_speed==0.0} { MOM_suppress once S M_spindle; }
  }

# 5)
global mom_spindle_drobl_status  fl_drobl
MOM_suppress once G_drobl U V;
if {[info exists mom_spindle_drobl_status]} {
  if {$mom_spindle_drobl_status == "ON"} {
    if {$fl_drobl == 0} {
          MOM_force once G_drobl U V
          set fl_drobl 1
    } else {
          MOM_force once G_drobl
      }
   }
}
# 6)
  set fl 0 ; MOM_suppress once G_slowdn
  set fl [ PB_slowdn_move ] ; #  
  if {$fl!=0} { MOM_force once G_slowdn ; }
# 7)
	global mom_pos mom_prev_pos
	set txd  [expr ($mom_pos(0)-$mom_prev_pos(0))] ;
	set tzd  [expr ($mom_pos(2)-$mom_prev_pos(2))] ;
	set tx [expr (abs($txd))] ;
	set tz [expr (abs($tzd))] ;

	global mom_kin_machine_resolution
	if {![EQ_is_zero $tz ]} {
   		if {[EQ_is_equal $tx $tz ]} {
   			global Afaska
    			if {[EQ_is_gt $tzd $mom_kin_machine_resolution]} { set Afaska  $tz  }
    			if {[EQ_is_lt $tzd $mom_kin_machine_resolution]} { set Afaska  -$tz }
    			MOM_do_template linear_Afaska
    			return
    		}
 	 }
  	MOM_do_template linear_move

}


#=============================================================
proc MOM_rapid_distantion { } {
#=============================================================
  global mom_rapid_distantion_flag mom_rapid_distantion_value mom_rapid_distantion_const

  set rv 0
  
  if {[info exists mom_rapid_distantion_flag]==0} { set mom_rapid_distantion_flag "OFF" }

  if {$mom_rapid_distantion_flag=="ON"} {
    ;#
    if {[info exists mom_rapid_distantion_value]} {
        if {$mom_rapid_distantion_value<=0} { set mom_rapid_distantion_flag OFF ; return 0 }
     } else { set mom_rapid_distantion_value $mom_rapid_distantion_const ; }
    ;#
     global mom_motion_distance
     if {[info exists mom_motion_distance]} {
     	;# MOM_output_text "mom_rapid_distantion_flag=$mom_rapid_distantion_flag"
     	;# MOM_output_text "mom_rapid_distantion_value=$mom_rapid_distantion_value"
     	;# MOM_output_text "mom_motion_distance=$mom_motion_distance"
     	;# MOM_output_text "mom_rapid_distantion_const=$mom_rapid_distantion_const"
      if {$mom_motion_distance<=$mom_rapid_distantion_value} { set rv 1 }
     }
    ;#
   }

  return $rv
}

#=============================================================
proc MOM_rapid_move { } {
# This procedure is executed for each rapid move. It gets called after the
# positioning varables, position and tool axis (X,Y,Z,TAX,TAY,TAZ) are loaded.
#=============================================================
	set fl 0
	set fl [ MOM_rapid_distantion ]
	if {$fl!=0} {
		MOM_suppress once F G_feed
		global mom_motion_event
		set mom_motion_event  "linear_move"
		MOM_linear_move
		return
	 }

  MOM_do_template rapid_move
}


#=============================================================
proc MOM_circular_move { } {
#=============================================================
# This procedure is executed for each circular move. It gets called after  the circle data are loaded (end point and center).
 global mom_cutcom_mode mom_cutcom_status

;#
global mom_spindle_drobl_status  fl_drobl
MOM_suppress once G_drobl U V;
if {[info exists mom_spindle_drobl_status]} {
  if {$mom_spindle_drobl_status == "ON"} {
     if {$fl_drobl == 0} {
          MOM_force once G_drobl U V
          set fl_drobl 1
    } else {
          MOM_force once G_drobl
      }
  }
}
;#

  set fl 0 ; MOM_suppress once G_slowdn
  set fl [ PB_slowdn_move ] ; #  
  if {$fl!=0} { MOM_force once G_slowdn ; }

  MOM_force once I K
  global mom_output_mode
  switch $mom_output_mode {
      ABSOLUTE {
 	 #
 	 proc outD { } {
 	  global mom_arc_direction mom_arc_radius
 	  if {$mom_arc_direction=="CLW"} {
    		set mom_arc_radius [expr (-1.0) * $mom_arc_radius]
    		MOM_force Once X ; MOM_suppress Once Z
   	   } else {
    		set mom_arc_radius [expr abs($mom_arc_radius)]
    		MOM_force Once Z ; MOM_suppress Once X
          }
           MOM_do_template circular_move_D
	 }
	 #
 	 set choice 2
 	 switch $choice {
 		1 {
 			global mom_pos mom_prev_pos
 			set tx [expr abs($mom_pos(0)-$mom_prev_pos(0))] ;
			set tz [expr abs($mom_pos(2)-$mom_prev_pos(2))] ;
			set txz [expr abs($tx-$tz)] ;
 			global mom_kin_machine_resolution
 			if {$txz <= $mom_kin_machine_resolution } {
 				outD
 			} else { MOM_do_template circular_move_absolut ;  }
		   }
 		default {
 			global mom_arc_angle
 	 		if {$mom_arc_angle == 90.0} {
 	 			 outD
 			} else { MOM_do_template circular_move_absolut ;  }
 		    }
 	   }
       }
   default { MOM_do_template circular_move_incr ; }
   }

}


#=============================================================
proc MOM_first_move { } {
#=============================================================
  catch { COOLANT_SET ; CUTCOM_SET ; SPINDLE_SET ; RAPID_SET ; MODES_SET ; }  errMes ; MOM_log_message "$errMes" ;
  global  mom_motion_event
  catch {MOM_$mom_motion_event} errMes ; MOM_log_message "$errMes" ;
}


#=============================================================
proc MOM_gohome_move { } {
#=============================================================
	MOM_do_template gohome
}


#=============================================================
proc MOM_return_move { } {
#=============================================================
 global  mom_feed_rate  mom_kin_rapid_feed_rate   feed
 global  mom_motion_type  mom_motion_event
 global  mom_programmed_feed_rate

  if {[info exists mom_kin_rapid_feed_rate]} {
    if { ( $mom_feed_rate >= $mom_kin_rapid_feed_rate ) || ( $feed >= $mom_kin_rapid_feed_rate ) }  { MOM_rapid_move ; return   }
    if { ($mom_programmed_feed_rate !=0) && ($mom_programmed_feed_rate < $mom_kin_rapid_feed_rate) } { MOM_linear_move; return  }
   }
 if {$mom_motion_event == "rapid_move"} {  MOM_rapid_move ;   return  } else { MOM_linear_move; return  }
 if {$mom_motion_type == "RAPID"} { MOM_rapid_move } else { MOM_linear_move }

}


  set accumulated_time 0
#=============================================================
proc MOM_end_of_path { } {
#=============================================================
# This procedure is executed at the end of a path.
  global mom_operation_name    mom_path_name
  global mom_machine_time
  global accumulated_time

  set op_time [expr $mom_machine_time - $accumulated_time]
  global mom_time
  if {[info exists mom_time]} {
    if {$mom_time=="ON"} {
      global  var_start_of_path_num  ; #   
      MOM_output_literal "(   $var_start_of_path_num=[format "%.2f" $op_time] )"
     }
  }
  set accumulated_time $mom_machine_time

}


#=============================================================
proc MOM_end_of_program { } {
#=============================================================
# This procedure is executed at the end of the program after all the paths are traversed.
  global mom_part_name
  global mom_warning_info
  global mom_output_file_basename

  global mom_machine_time
  MOM_output_to_listing_device "\n********************************************************************************"
  proc outTime { valueTime } {
	set tm1 [ expr int($valueTime/60.0) ]
  	set tm2 [ expr ($valueTime/60.0 - $tm1) * 60.0 ]
  	set str [format "( %.0f  %.0f )" $tm1 $tm2]
  	if {$tm1==0} { set str "" }
  	return $str
  }
  set str1 "    =[format "%.2f" $mom_machine_time ] "
  set str2 [ outTime $mom_machine_time ]
  MOM_output_to_listing_device "$str1  $str2"  ;

  global mom_time
  if {[info exists mom_time]} {
    if {$mom_time=="ON"} { MOM_output_literal "$str2" ; }
   }

  global mom_tool_count mom_tool_use
  if {[hiset mom_tool_count]} {
    for { set nn 0 } { $nn < $mom_tool_count } {incr nn} {
      if {[hiset mom_tool_use($nn,0)] && [hiset mom_tool_use($nn,1)]} {
         set a [scan $mom_tool_use($nn,0) %d tn]
         set str2 ""
         set str2 [ outTime $mom_tool_use($nn,1) ]
         MOM_output_to_listing_device " TOOL [ format "%s  %.2f" $tn $mom_tool_use($nn,1)]   $str2"
        }
     }
  }
  MOM_output_to_listing_device "********************************************************************************"

  MOM_do_template spindle_coolant_off
  MOM_do_template end_of_program
  global mom_rewind_end_of_program
  if {$mom_rewind_end_of_program==1} { MOM_do_template rewind_end_of_program ; }

  MOM_set_seq_off

  LIST_FILE_TRAILER ; #**** The following procedure lists the tool list with time in commentary data
  CLOSE_files ; #**** The following procedure closes the warning and listing files

 ;#
  global mom_sys_warning_output
  global warning_file_name
  if {$mom_sys_warning_output == "ON"} {
    if {[file exists $warning_file_name]} {
        set sz 0
        catch { set sz [ file size $warning_file_name ] ; }
        if {$sz<=53} {
        	catch { MOM_remove_file $warning_file_name ; } errMes ; MOM_log_message "$errMes" ;
        	# MOM_output_to_listing_device  "  REMOVED PRE-EXISTING MAIN $warning_file_name"
         }
    }
  }
  ;#
  global ptp_file_name
  global mom_sys_ptp_output
  if {$mom_sys_ptp_output == "ON"} {
	if {[file exists $ptp_file_name]} {
		#!!!
		MOM_close_output_file $ptp_file_name
		#!!!
		set sz 0
        	catch { set sz [ file size $ptp_file_name ] ; } errMes ; MOM_log_message "$errMes" ;
        	set nz ""
        	if {$sz>1024} {
        		set sr [ expr $sz/1024.0 ]
        		set sz [ format "%.2f" $sr ]
        		set nz "K"
        	}
        	MOM_output_to_listing_device "********************************************************************************"
        	MOM_output_to_listing_device "   ==$ptp_file_name"
        	MOM_output_to_listing_device "  =$sz $nz"
        	MOM_output_to_listing_device "********************************************************************************"
	}
	# puts stdout  "  "
	# puts stdout  "  GENERATING        : $ptp_file_name"
    }
  ;#

}


#=============================================================
proc PB_CMD_spindle_rpm_range_select { } {
#=============================================================
#  This procedure will output RPM mode only.  use this in mill posts.
#
#  This procedure will select the appropriate spindle range based
#  on the spindle table provided in post builder.  This procedure
#  will generate the mom variable mom_spindle_range which is
#  used in the WORD M_range.  The user must define the code for the
#  mom_variable mom_sys_spindle_range_code($mom_range_code).  By
#  default this is an m code.  You can change it to any code desired
#  by making the M_range leader blank, the format string and the  code any text needed.
#
#  You must place the word M_range in the appropriate block template.
#  You must place this custom command in a block before you output the spindle range code.
#

 global mom_sys_spindle_param   mom_sys_spindle_ranges
 global mom_spindle_mode  mom_spindle_range
 global mom_spindle_rpm mom_spindle_sfm mom_spindle_speed

 if {[info exists mom_spindle_range]} {
   if [catch {expr {2 * $mom_spindle_range}}] { set mom_spindle_range 1 ; }
 } else { set mom_spindle_range 1 ; }

 if {![info exists mom_sys_spindle_param]} { return ; }

 if {[info exists mom_spindle_rpm] && $mom_spindle_rpm > 0.0} {
    set speed $mom_spindle_rpm
  } else {
    set speed $mom_spindle_speed
 }

 if {![info exists mom_sys_spindle_ranges]} { set mom_sys_spindle_ranges 2 ; }

 for {set i 1} {$i <= $mom_sys_spindle_ranges} {incr i} {
  if {$speed > $mom_sys_spindle_param($i,min) && $speed < $mom_sys_spindle_param($i,max) } {

    if {$speed > $mom_sys_spindle_param(2,min) && $speed < $mom_sys_spindle_param(1,max) } {
       MOM_output_to_listing_device "!       2- "
       MOM_output_to_listing_device "\t !(?  ,  -   )"
       return
    }
    set mom_spindle_range $i
    return
  }

 }
  set mom_spindle_range 1 ;

}

#=============================================================
proc MOM_spindle_rpm { } {
#=============================================================
# This procedure is executed when the Spindle command is activated.
   global mom_spindle_text   mom_spindle_direction
   global mom_spindle_speed

   SPINDLE_SET

   if {[info exists  mom_spindle_direction]} {
      if {[string toupper $mom_spindle_direction]=="ORIENT"} {
           set mom_warning_info "WARNING:    (M19)\n"
           MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
           MOM_do_template spindle_orient
           return ;
      	}
   }

   if {[info exists  mom_spindle_text]} {
      if {[string toupper $mom_spindle_text]=="ORIENT"} {
      	   set mom_spindle_direction  "ORIENT" ;
           set mom_warning_info "WARNING:    (M19)\n"
           MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
           MOM_do_template spindle_orient
           return ;
      	}
   }

  PB_CMD_spindle_rpm_range_select

  MOM_force once S M_spindle M_range
  MOM_do_template spindle_rpm
}


#=============================================================
proc MOM_spindle_css { } {
#=============================================================
	SPINDLE_SET
}

#=============================================================
proc MOM_spindle_off { } {
#=============================================================
# This procedure is executed when the Spindle command is deactivated.
   global mom_spindle_text   mom_spindle_direction
   if {[info exists  mom_spindle_text]} {
      if {[string toupper $mom_spindle_text]=="ORIENT"} {
           set mom_warning_info "WARNING:    (M19)"
           MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
           MOM_force once M_spindle
           MOM_do_template spindle_orient
      	}
   }
  SPINDLE_SET
  MOM_force once M_spindle
  MOM_do_template spindle_off
}


#=============================================================
proc MOM_coolant_on { } {
#=============================================================
# This procedure is executed when the Coolant command is activated.
#  COOLANT_SET
	global mom_coolant_status  mom_coolant_mode
 	set mom_coolant_status $mom_coolant_mode
# 	MOM_force Once M_coolant
	MOM_do_template coolant_on
}

#=============================================================
proc MOM_coolant_off { } {
# This procedure is executed when the Coolant command is deactivated.
#=============================================================
  global mom_coolant_mode mom_coolant_status
  COOLANT_SET
  set mom_coolant_status "OFF"
  MOM_do_template coolant_off
}


#=============================================================
proc MOM_cutcom_on { } {
#=============================================================
# This procedure is executed when the Cutcom command is activated.
  global mom_cutcom_status   mom_cutcom_mode
  catch {unset mom_cutcom_mode}
  if {[info exists mom_cutcom_mode]} { set mom_cutcom_status $mom_cutcom_mode }
  
  global mom_cutcom_status_view
  catch { CUTCOM_SET }

global mom_on_option ;# "None","Before each Engage" "Before each Engage","After each Engage","Before 1st Motion"
global mom_off_option;# "None","Before each Retract" "Before each Retract","After each Retract","After Last Motion"
global mom_cutcom_adjust_instrument ;# "ON","OFF"
global mom_cutcom_adjust_register ;# " "
global mom_cutcom_adjust_x ;#"   X"
global mom_cutcom_adjust_z ;#  "   Z"
global mom_cutcom_text ;# "Text"
if  {[info exists mom_cutcom_status_view]} {
  if {$mom_cutcom_status_view== "OFF"} {  
        MOM_force once G_cutcom ;    
     #   MOM_cutcom_off ; 
        return ;}
  if {$mom_cutcom_status_view== "ON"} { 
    set str "G63/"
    if  {$mom_cutcom_adjust_instrument=="ON"} { 
        if  {$mom_cutcom_mode=="LEFT"} { set sA "A" ; set str $str$sA ; }
        if  {$mom_cutcom_mode=="Right"} {  set sA "-A" ; set str $str$sA ; }
     }
    set str $str$mom_cutcom_adjust_register,
    if  {[info exists mom_cutcom_adjust_x]} { 
          set str $str$mom_cutcom_adjust_x,  ;
     } else { 
          set str $str,  ;
       }
    if  {[info exists mom_cutcom_adjust_z]} {  
             set str $str$mom_cutcom_adjust_z/  ; 
      } else {
         set str $str/  ; 
         }
   MOM_output_literal "$str" ;  # MOM_do_template cutcom_on
    }
 }
  
  
}

#=============================================================
proc MOM_cutcom_off { } {
#=============================================================
# This procedure is executed when the Cutcom command is deactivated.
  	CUTCOM_SET
  global mom_cutcom_status mom_cutcom_mode
  catch {unset mom_cutcom_mode}
  MOM_do_template cutcom_off
}


#=============================================================
proc MOM_tool_preselect { } {
#=============================================================
  global mom_tool_preselect_number mom_tool_number mom_next_tool_number
  global mom_warning_info
  set mom_warning_info "WARNING:     '242'   \[ tool_preselect\]"
  MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}

#=============================================================
proc MOM_length_compensation { } {
#=============================================================
# This procedure is executed when the set adjust for length compensation is activated.
# A new set offset register is taken with T command and is output with the immediate next motion commant.
   global mom_tool_number mom_tool_adjust_register  mom_length_comp_register
	TOOL_SET MOM_length_compensation
   MOM_force ONCE M T
   catch { MOM_do_template tool_change_length_compensation } errMes ; MOM_log_message "$errMes" ;
}

#=============================================================
proc MOM_first_tool { } {
#=============================================================
  global mom_tool_change_type mom_manual_tool_change
   PB_TURRET_HEAD_SET
}


#=============================================================
proc PB_auto_tool_change { } {
#=============================================================
		MOM_force Once X Z
   		MOM_do_template tool_change_axis_preset
		global mom_sys_leader
		set saved_seq_num $mom_sys_leader(N)
		set mom_sys_leader(N) ":"
		MOM_force Once M T ;
  		catch { MOM_do_template tool_change } errMes; MOM_log_message "$errMes" ;
  		#Return sequnece number back to orignal
		set mom_sys_leader(N) $saved_seq_num
}


#=============================================================
proc PB_manual_tool_change { } {
#=============================================================
		MOM_force once X Z G M
		MOM_do_template manual_tool_change
		MOM_do_template stop
}

#=============================================================
proc MOM_load_tool { } {
#=============================================================
   global mom_tool_change_type mom_manual_tool_change
   PB_TURRET_HEAD_SET
   if {[info exists mom_tool_change_type]} {
      switch $mom_tool_change_type {
         MANUAL { PB_manual_tool_change }
         AUTO   { PB_auto_tool_change }
      }
   } elseif {[info exists mom_manual_tool_change]} {
      if {$mom_manual_tool_change == "TRUE"} {
         PB_manual_tool_change
      }
   }
}

#=============================================================
proc MOM_tool_change { } {
#=============================================================
  global mom_tool_change_type mom_manual_tool_change
   PB_TURRET_HEAD_SET

}

#=============================================================
proc PB_TURRET_HEAD_SET { } {
#=============================================================
  global mom_kin_independent_head mom_tool_head
  global turret_current mom_warning_info

    set turret_current INDEPENDENT

    if {$mom_tool_head != $mom_kin_independent_head} {
      set turret_current DEPENDENT
    }

    if {$mom_tool_head != "NONE" && \
         $mom_tool_head != "NONE"} {
      set mom_warning_info "$mom_tool_head IS INVALID, USING NONE" ; MOM_catch_warning
    }
}


#=============================================================
proc MOM_delay { } {
#=============================================================
  global mom_sys_delay_param mom_delay_value
  global mom_delay_revs mom_delay_mode delay_time
  global mom_warning_info

   # post builder provided format for the current mode:
    if {[info exists mom_sys_delay_param(${mom_delay_mode},format)] != 0} {
      MOM_set_address_format E $mom_sys_delay_param(${mom_delay_mode},format)
    }

    switch $mom_delay_mode {
      SECONDS {set delay_time $mom_delay_value}
      default {
         set delay_time $mom_delay_revs ;
         set mom_warning_info "WARNING:      . !"
         MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
      }
    }

  	MOM_force once E G_dwell
  	MOM_do_template delay
}


#=============================================================
proc MODES_SET { } {
#=============================================================
   global mom_machine_mode  mom_feed_set_mode  mom_feed_rate_output_mode
   global mom_output_mode  mom_arc_mode
   global mom_parallel_to_axis  mom_modes_text
   global mom_warning_info

; # "ABSOLUTE", "INCREMENTAL"
  switch $mom_output_mode {
    ABSOLUTE { set isincr OFF }
    default  { set isincr ON }
  }
  MOM_incremental $isincr X Z

; # "LINEAR", "CIRCULAR"
  if {$mom_arc_mode == "LINEAR"} {
  } elseif {$mom_arc_mode == "CIRCULAR"} {
  }

# "OFF", "IPM", "IPR", "MMPM", "MMPR", "INVERSE"
  switch $mom_feed_rate_output_mode {
    MMPM { ; }
    OFF  { ; }
    default  {
       set mom_warning_info "WARNING:    '242'   / (     /)"
       MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
       set mom_feed_rate_output_mode  "MMPM"
     }
  }

# "ZAXIS", "WAXIS", "UAXIS"
  switch $mom_parallel_to_axis {
    ZAXIS { ; }
    default  {
       set mom_warning_info "WARNING:     Z (    Z)"
       MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
       set mom_parallel_to_axis  "ZAXIS"
     }
  }

# "MILL", "TURN", "PUNCH", "LASER", "TORCH", "WIRE"
  switch $mom_machine_mode {
    TURN { ; }
    default  {
       set mom_warning_info "WARNING:       (    TURN)"
       MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
       set  mom_machine_mode  "TURN"
     }
  }

}

#=============================================================
proc MOM_set_modes { } {
#=============================================================
# This procedure is executed for the Set Mode command.
   global mom_machine_mode  mom_feed_set_mode
   global mom_output_mode  mom_arc_mode
   global mom_parallel_to_axis  mom_modes_text
   global mom_warning_info
   global mom_prefun  mom_prefun_text
   MODES_SET

   ;#  COARSE/FINE
   if {[info exists  mom_modes_text]} {
      switch [string toupper $mom_modes_text] {
        COARSE {
            set mom_prefun 36 ; MOM_prefun ;
            set mom_warning_info "WARNING:          . (   G$mom_prefun)\n"
            append mom_warning_info "\t          mom_arc_mode=CIRCULAR"
            MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
          }
        FINE {
            set mom_prefun 37 ; MOM_prefun ;
            set mom_warning_info "WARNING:           ( G$mom_prefun)\n"
            append mom_warning_info "\t          mom_arc_mode=LINEAR"
            MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
          }
         default {
          set mom_warning_info "WARNING:   \[$mom_modes_text\].  \[MOM_set_modes\]"
          MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
         }
      }
   }

}


#=============================================================
proc MOM_stop { } {
#=============================================================
# This procedure is executed when the Program Stop command is activated.
	MOM_do_template stop
}


#=============================================================
proc MOM_opstop { } {
#=============================================================
	MOM_do_template opstop
}


#=============================================================
proc MOM_auxfun { } {
#=============================================================
 MOM_do_template auxfun
}


#=============================================================
proc MOM_prefun { } {
#=============================================================
 MOM_do_template prefun
}


#=============================================================
proc  MOM_opskip_on {} {
#=============================================================
#__This procedure is executed when the Optional skip command is activated.
  global mom_sys_opskip_block_leader
  MOM_set_line_leader always "$mom_sys_opskip_block_leader"
}

proc  MOM_opskip_off {} {
#=============================================================
#__ This procedure is executed when the Optional skip command is activated.
  global mom_sys_opskip_block_leader
  MOM_set_line_leader off "$mom_sys_opskip_block_leader"
}


#==================================================================
proc MOM_path_warning { } {
#==================================================================
# This procedure is executed when the in CLSF file has Inconsistent axis.
  global mom_path_warning
  if {[info exists mom_path_warning]} {
     if {[string length $mom_path_warning]!=0} {
     	global mom_seqnum  mom_warning_info
     	set tmpNum [format "%.0f" $mom_seqnum]
        set mom_warning_info "!! :      ( ?     )\t\n = $mom_path_warning ( =$tmpNum)"
     	MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
     	}
   }
  #MOM_abort $mom_warning_info
}


#=============================================================
proc  MOM_clamp {} {
#=============================================================
#     G      .
 global mom_clamp_status mom_clamp_axis mom_clamp_text
 global mom_auxfun mom_auxfun_text ;
 global mom_warning_info

 if {[info exists mom_clamp_text]} {
   if {$mom_clamp_text != ""} { set mom_auxfun_text $mom_clamp_text }
 }

if {[string toupper $mom_clamp_status]=="OFF"} {
 switch [string toupper $mom_clamp_axis] {
  "XAXIS" { set str 79 ; }
  "YAXIS" { set str 81 ; }
  "ZAXIS" { set str 83 ; }
  "AAXIS" { set str 85 ; }
   default
         {
          set mom_warning_info "WARNING:    ( X,Y,Z,A())"
          MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
          return ;
         }
  }
 set mom_auxfun $str ; MOM_auxfun  ; return ;
}

if {[string toupper $mom_clamp_status]=="ON"} {
 switch [string toupper $mom_clamp_axis] {
  "XAXIS" { set str 78 ; }
  "YAXIS" { set str 80 ; }
  "ZAXIS" { set str 82 ; }
  "AAXIS" { set str 84 ; }
   default
         {
          set mom_warning_info "WARNING:    ( X,Y,Z,A())"
          MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
          return ;
         }
  }
 set mom_auxfun $str ; MOM_auxfun ; return ;
}

 set mom_warning_info "WARNING:    ( \{X,Y,Z,A()\}+ \{ON  OFF\})"
 MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}


#=============================================================
proc MOM_lock_axis { } {
#=============================================================
#     G      .
 global mom_warning_info
 set mom_warning_info "WARNING:  \[lock_axis\]  "
 MOM_output_text  "(event MOM_lock_axis )"
 MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}


#=============================================================
proc  MOM_pprint {} {
#=============================================================
#___ This procedure is executed when the Text command is activated.
 global mom_pprint ;
 global mom_warning_info

 if {[info exists mom_pprint]} {
  if {$mom_pprint!=""} {
     set var1 "" ;
     set st [regsub -nocase  -- {(%)+}  $mom_pprint  ""  var1 ] ; set mom_pprint $var1 ;
     set st [regsub -nocase  -- {(:)+}  $mom_pprint  ""  var1 ] ; set mom_pprint $var1 ;
     set st [regexp -nocase -- {[a-z]} $mom_pprint var1]
     if {$st!=0} {
       set mom_warning_info "WARNING:       "
       MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
     }
     MOM_output_literal "($mom_pprint)"
   }
  }

}


#=============================================================
proc  MOM_operator_message {} {
#=============================================================
# This procedure is executed when the Operator Message command is activated.
   global mom_operator_message_defined   mom_operator_message
   if {$mom_operator_message_defined !=  0} {
       MOM_output_literal "G30/$mom_operator_message/"
   }
}


#=============================================================
proc  MOM_zero {} {
#=============================================================
#     G      .
#         Fanuc.
#   G   ZERO/CHECK, ZERO/ON, ZERO/OFF, ZERO/THRU,   G   ZERO/n.
 global mom_sys_wcs_change_code mom_work_coordinate_number
 global mom_warning_info

 if {$mom_work_coordinate_number<0} {
  if {$mom_work_coordinate_number==-1} {
     MOM_force  once  G_return
     MOM_do_template sys_ref_point_return
     MOM_suppress always G_return
     set mom_warning_info ":         (G25) -  1     (work_coordinate_number=$mom_work_coordinate_number)"
     MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
     return ;
   }
  if {$mom_work_coordinate_number==-2} {
     MOM_force  once  G_return
     set mom_warning_info ":      (G26),    (work_coordinate_number=$mom_work_coordinate_number)"
     MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
     return ;
   }
 }

 if {$mom_work_coordinate_number<0 || $mom_work_coordinate_number>4} {
   set mom_warning_info "WARNING: work_coordinate_number=\[0 (),1,2,3,4\]"
   MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
 }
 set mom_sys_wcs_change_code [ expr ($mom_sys_wcs_change_code + $mom_work_coordinate_number)]
 MOM_force once G_return G_mode G_cutcom
 MOM_do_template sys_wcs_change

 return ;
}

#=============================================================
proc MOM_sequence_number { } {
#=============================================================
   SEQNO_SET
}

#=============================================================
proc MOM_origin {} {
#=============================================================
  global mom_origin_point ;
  global mom_warning_info ;
  set mom_warning_info "WARNING:   X, Z -  "
  MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}


#=============================================================
proc MOM_text {} {
#=============================================================
# This procedure is executed when the Text command is activated.

  global mom_user_defined_text mom_record_text mom_record_fields mom_field_count
  global mom_Instruction
  global mom_sys_control_out mom_sys_control_in
  global mom_operator_message mom_operator_message_defined
  global mom_pprint_defined mom_pprint
  global mom_warning_info

  switch [string toupper $mom_record_fields(0)] {
   "SET"  { ; }
  "PPRINT" {
           set mom_pprint_defined 1
           set mom_pprint $mom_record_text
           MOM_pprint
           }
  "DISPLY" {
           set mom_operator_message_defined 1
           set mom_operator_message $mom_record_text
           MOM_operator_message
          }
  "INSERT" {
           if {[info exists mom_record_fields(1)]}  {
              set mom_Instruction [string toupper $mom_record_text ] ; #$mom_record_fields(1)] ;
              MOM_insert
              set mom_warning_info "WARNING:    'INSERT/$mom_Instruction' -  \n"
              MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
           }
         }
  "PARTNO" { ; #   ()
           global partno_program
           set partno_program  "" ;
           set str "User Defined"
           if {[info exists  mom_record_fields(1)]} {
             set partno_program $mom_record_text ; # $mom_record_fields(1)
           }  else  {
              set RNseed [clock clicks] ;
              set RNseed [expr (30903 * ($RNseed & 65535) + ($RNseed>>16))]
              set RNseed [expr (($RNseed & 65535)/65535.0)]
              set RNseed [expr $RNseed*100000.0]
              set RNseed [expr int($RNseed)]
              set partno_program [format "%5d" $RNseed]
              set str "."
           }
           set mom_warning_info "<!--\n PARTNO-> \[  () - !   \]=$partno_program ($str)\n-->"
           MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
         }
  "REWIND" {
            global mom_rewind_end_of_program ; set mom_rewind_end_of_program 1 ;
            set mom_warning_info "<!--\n REWIND-> \[ \]=M30;\n-->"
            MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
           }
  "MACALL" { ; #  
           set n 0
           if {[info exists mom_record_fields(1)]} {
             set str  $mom_record_fields(1);
             if [catch {expr {2 * $str}}] { set str 0 ; }
             if {$str<0} { set str 0 ; }
             set n [expr int($str) ];
            }
           set m 0 ;
           if {[info exists mom_record_fields(2)]} {
             if {[string toupper $mom_record_fields(2)]=="REPEAT"} {
               if {[info exists mom_record_fields(3)]} {
                  set str  $mom_record_fields(3);
                  if [catch {expr {2 * $str}}] { set str 0 ; }
                  if {$str<0} { set str 0 ; }
                  set m [expr int($str) ]
                }
              } else {
                  set str  $mom_record_fields(2);
                  if [catch {expr {2 * $str}}] { set str 0 ; }
                  if {$str<0} { set str 0 ; }
                  set m [expr int($str) ]
                }
            }
           global  start_subprogram_code ;
           if {$m==0} { set m  1 ; }
           if {$m>99} { set m  99 ; }
           set m [ expr $m/100.0 ] ;
           set tm [ expr $n+$m ] ;
           set start_subprogram_code $tm ;
           MOM_force once  L_start
           MOM_do_template  start_of_subprogram ;
           set mom_warning_info "<!--\n MACALL-> \[ \]=$start_subprogram_code;\n-->"
           MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
          }
  "MACND" { ; #  
           global flag_subprogram; set flag_subprogram 0 ;
           MOM_do_template  end_of_subprogram ;
           MOM_do_template  end_of_program ;
           global mom_sys_seqnum_start  mom_sys_seqnum_incr  mom_sys_seqnum_freq ;
           MOM_set_seq_off
           MOM_reset_sequence $mom_sys_seqnum_start  $mom_sys_seqnum_incr  $mom_sys_seqnum_freq ;
           MOM_set_seq_on
           set mom_warning_info "<!--\n MACND-> \[ \];\n-->"
           MOM_output_to_listing_device $mom_warning_info  ; MOM_catch_warning ;
           }
  "MACST" {  ; #  () 
           global number_subprogram ; incr number_subprogram ;
           global flag_subprogram; set flag_subprogram 1 ;
           set n 0
           if {[info exists mom_record_fields(1)]} {
             set str [string toupper $mom_record_fields(1)]
             if [catch {expr {2 * $str}}] { set str 0 ; }
             if {$str<0} { set str 0 ; }
             set n [expr int($str) ];
            }
           set str "" ;
           for { set i 2 } { $i<$mom_field_count } { incr i } {
            if {[info exists mom_record_fields($i)]} {
             append str [string toupper $mom_record_fields($i)];
            }
           }
           if {$n>99} {
             set mom_warning_info "WARNING:   > 99 = ($n)\n-->"
             MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
           }
           global def_subprogram_code  subprogram_text
           set def_subprogram_code $n
           set subprogram_text $str ;
           MOM_suppress once Text
           if {[info exists  subprogram_text]} {
             if {$subprogram_text != ""} { MOM_force  once  Text }
           }

           MOM_set_seq_off
           MOM_force once  L_def
           MOM_do_template def_of_subprogram
           MOM_reset_sequence [expr $n * 1000 ]  1 1
           MOM_set_seq_on
           set mom_warning_info "<!--\n MACST-> \[ () \];\n-->"
           MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
           }
  "STLOOP" { ; #   
           set n 0
           if {[info exists mom_record_fields(1)]} {
             set str  $mom_record_fields(1);
             if [catch {expr {2 * $str}}] { set str 0 ; }
             if {$str<0} { set str 0 ; }
             set n [ expr int($str) ] ;
            }
           set str "" ;
           for { set i 2 } { $i<$mom_field_count } { incr i } {
            if {[info exists mom_record_fields($i)]} {
             append str [string toupper $mom_record_fields($i)];
            }
           }
           global stloop_text  stloop_code
           set stloop_code  $n  ;
           set stloop_text $str ;
           MOM_suppress once Text
           if {[info exists stloop_text]} {
             if {$stloop_text != ""} { MOM_force  once  Text }
           }
           MOM_force once H
           MOM_do_template stloop
           set mom_warning_info "<!--\n STLOOP-> \[  \]  =$stloop_code ;\n-->"
           MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
          }
  "NDLOOP" { ; #   
            global mom_auxfun mom_auxfun_text ;
            set mom_auxfun 20 ;set mom_auxfun_text "" ; MOM_auxfun ;
            set mom_warning_info "<!--\n NDLOOP-> \[  \]=$mom_auxfun ;\n-->"
            MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
           }
  "SAFETY" { ; #       
           switch [string toupper $mom_record_fields(1)] {
            "FEED" { set str 20 ; }
            "SPINDLE" { set str 21 ; }
            "ON" { set str 22 ; }
            "OFF" { set str 23 ; }
            default {
              set mom_warning_info "WARNING:   !($mom_user_defined_text)"
              MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
              MOM_output_literal $mom_user_defined_text
              return ;
              }
            }
           global mom_prefun mom_prefun_text ; set mom_prefun $str ; set mom_prefun_text "" ;
           MOM_prefun ;
           set mom_warning_info "<!--\n SAFETY-> [string toupper $mom_record_fields(1)] \[      \]=$str ;\n-->"
           MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
         }
  "SELECT" { ; #  
           switch [string toupper $mom_record_fields(1)] {
             "PALLET" {
                       if {[info exists mom_record_fields(2)]} {
                          set str  $mom_record_fields(2);
                          if [catch {expr {2 * $str}}] { set str 0 ; }
                          global mom_auxfun mom_auxfun_text ;
                          if {$str<60 || $str>63} {
                            if {$str<0} { set str 0 ; }
                            if {$str>3} { set str 3 ; }
                            set str [expr 60 + $str] ;
                           }
                          set mom_auxfun [expr $str] ; set mom_auxfun_text "" ; MOM_auxfun  ; #MOM_output_literal "M$str"
                          set mom_warning_info "<!--\n SELECT-> PALLET \[ \]\n =$mom_auxfun ;\n-->"
                          MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
                        }
                      }
              default {
                       set mom_warning_info "WARNING:   !($mom_user_defined_text)"
                       MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
                      }
            }
          }
  "SLOWDN" {  ; #    
           global SLOWDN_MIN_ANGLE  SLOWDN_MAX_FEED  ; # 
           global mom_modes_slowdn      ; #   ON/OFF/AUTO
           global mom_modes_slowdn_feed ; #   ON/OFF
           global mom_slowdn_min_angle  ;
           global mom_slowdn_max_feed   ;

           set mom_modes_slowdn       "AUTO"  ;
           set mom_slowdn_min_angle   $SLOWDN_MIN_ANGLE ;
           set mom_modes_slowdn_feed  "OFF"   ;
           set mom_slowdn_max_feed    $SLOWDN_MAX_FEED  ;

           set messageinfo "   SLOWDN \[\] \n "
           append messageinfo "  ,   SLOWDN,     ,   \n   . ,             \n \[ \].\n"
           append messageinfo " SLOWDN    ,        .    \n"
           append messageinfo "   .            \n       .\n"
           append messageinfo "\n :    ,   .\n"
           append messageinfo "\n : SLOWDN/ \{ ON | OFF | AUTO \[,\"angle\"\] \} \{, MAXFEED \[, \"maxFeed\" \] \} \n"
           append messageinfo "\n :\n"
           append messageinfo " 1. \"ON\"    ,    ,       .\n"
           append messageinfo " 2. \"OFF\"     .\n"
           append messageinfo " 3. \"AUTO\"    ,    ,     \n\t  ,          \"angle\" .\n"
           append messageinfo " 4. \"angle\"     ,    .     ,  \n\t  $mom_slowdn_min_angle .\n"
           append messageinfo " 5. \"MAXFEED\"          $mom_slowdn_max_feed.\n"
           append messageinfo " 6. \"MAXFEED\",\"maxFeed\"     \"maxFeed\",    .\n"
           append messageinfo "\n:\n"
           append messageinfo " 1.   ,       .    ,   . \n"
           append messageinfo " 2.         \n"
           append messageinfo " 3. OFF   .\n"

           set error_flag  0; #  
           set fl_goto     0; #  

           if {[info exists mom_record_fields(1)]} {
             set str $mom_record_fields(1);
             switch [string toupper $str] {
              "?"       { set mom_modes_slowdn  "OFF" ; set mom_modes_slowdn_feed  "OFF" ; set mom_warning_info "$messageinfo\n" ; MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ; }
              "ON"      { set mom_modes_slowdn  "ON"  ; }
              "OFF"     { set mom_modes_slowdn  "OFF" ; }
              "AUTO"    { set mom_modes_slowdn  "AUTO"; }
              "MAXFEED" { set mom_modes_slowdn_feed  "ON" ; set mom_modes_slowdn  "OFF" ; }
              default  {
                         if [catch {expr {2.0 * $str}}] { set str $mom_slowdn_min_angle ; set error_flag 1; }
                         if {$str<0.0} { set str $mom_slowdn_min_angle ; set error_flag 1; }
                         set mom_slowdn_min_angle [expr double($str) ]; set fl_goto 1;
                       }
              }
           }

           if {[info exists mom_record_fields(2)]} {
             set str $mom_record_fields(2);
             switch [string toupper $str] {
              "?"       { set mom_modes_slowdn  "OFF" ; set mom_modes_slowdn_feed  "OFF" ; set mom_warning_info "$messageinfo\n" ; MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ; }
              "MAXFEED" { set mom_modes_slowdn_feed  "ON" ; }
              default  {
                         if {"$mom_modes_slowdn_feed"=="ON"} {
                           if [catch {expr {2.0 * $str}}] { set str $mom_slowdn_max_feed ; set error_flag 1; }

                           if {$str<0.0} { set str $mom_slowdn_max_feed ; set error_flag 1; }
                           set mom_slowdn_max_feed [expr double($str) ];
                         } else {
                           if {$fl_goto==1} {
                             if [catch {expr {2.0 * $str}}] { set str $mom_slowdn_max_feed ; set error_flag 1; }
                             if {$str<0.0} { set str $mom_slowdn_max_feed ; set error_flag 1; }
                             set mom_slowdn_max_feed [expr double($str) ];
                             set mom_modes_slowdn_feed  "ON" ;
                            } else {
                               if [catch {expr {2.0 * $str}}] { set str $mom_slowdn_min_angle ; set error_flag 1; }
                               if {$str<0.0} { set str $mom_slowdn_min_angle ; set error_flag 1; }
                               set mom_slowdn_min_angle [expr double($str) ];
                             }
                         }
                       }
              }
           }

           if {[info exists mom_record_fields(3)]} {
             set str $mom_record_fields(3);
             switch [string toupper $str] {
              "?"       { set mom_modes_slowdn  "OFF" ; set mom_modes_slowdn_feed  "OFF" ;  set mom_warning_info "$messageinfo\n" ; MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ; }
              "MAXFEED" { set mom_modes_slowdn_feed  "ON" ; }
              default {
                        if {"$mom_modes_slowdn_feed"=="ON"} {
                         if [catch {expr {2.0 * $str}}] { set str $mom_slowdn_max_feed ; set error_flag 1; }
                         if {$str<0.0} { set str $mom_slowdn_max_feed ; set error_flag 1; }
                         set mom_slowdn_max_feed [expr double($str) ];
                        }
                      }
              }
           }

           if {[info exists mom_record_fields(4)]} {
             set str $mom_record_fields(4);
             switch [string toupper $str] {
              "?"       { set mom_modes_slowdn  "OFF" ; set mom_modes_slowdn_feed  "OFF" ;set mom_warning_info "$messageinfo\n" ; MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ; }
              default {
                        if {"$mom_modes_slowdn_feed"=="ON"} {
                         if [catch {expr {2.0 * $str}}] { set str $mom_slowdn_max_feed ; set error_flag 1; }
                         if {$str<0.0} { set str $mom_slowdn_max_feed ; set error_flag 1; }
                         set mom_slowdn_max_feed [expr double($str) ];
                        }
                      }
              }
           }

           if {$error_flag!=0} {
              set mom_warning_info "============\n! \[ User Defined\]    '$mom_user_defined_text'?,  ! (  - )"
              MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
              set mom_modes_slowdn  "OFF" ; set mom_modes_slowdn_feed  "OFF" ;
            }

              set mom_warning_info "<!--\n SET-> SLOWDN \[\]\n =$mom_modes_slowdn ; =$mom_slowdn_min_angle ; ()=$mom_modes_slowdn_feed ; =$mom_slowdn_max_feed \n-->"
              MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
          }
  "TIME" {
          global mom_time ;
          set  mom_time  ON ;
          if {[info exists mom_record_fields(1)]} {
           if {$mom_record_fields(1) == "OFF"} { set  mom_time  OFF ; }
           }
          set mom_warning_info "<!--\n TIME-> TIME \[ \]\n =$mom_time ;\n-->"
          MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
         }
  "ZERO" {
          global  mom_work_coordinate_number
          set mom_work_coordinate_number $mom_record_fields(1)
           MOM_zero
         }
 default {
            set mom_warning_info "WARNING:   !($mom_user_defined_text)"
            MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
            MOM_output_literal $mom_user_defined_text
         }
  }
}


##########################################################################################
#=============================================================
proc VEC_angle_calc { } {
 ; # 1 -       (....), 0 -  
 set flag  0
 ; # 1 -     QUADRANT ; 0 -      mom_kin_arc_output_mode;
 set tpCircular  0

#=============================================================
 global  mom_warning_info

 global mom_kin_read_ahead_next_motion
 if {![info exists mom_kin_read_ahead_next_motion]} {
   set mom_warning_info "! \[proc VEC_angle_calc\]  mom_kin_read_ahead_next_motion=\"\" ! ( )"
   MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
   MOM_abort "$mom_warning_info"
 }

 global  mom_kin_arc_output_mode
 if {[info exists tpCircular]} {
  if {"$tpCircular"=="1"} {
   if {[info exists mom_kin_arc_output_mode]} {
    if {"$mom_kin_arc_output_mode"!="QUADRANT"} {
      set mom_kin_arc_output_mode "QUADRANT" ; #"FULL_CIRCLE"
      set mom_warning_info "! \[proc VEC_angle_calc\]  mom_kin_arc_output_mode=$mom_kin_arc_output_mode ( )"
      MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
      MOM_reload_kinematics ;
      set tpCircular  0 ;
    }
   }
  }
 }

#=============================================================
 global mom_nxt_event  mom_nxt_event_count  mom_nxt_motion_event
 global mom_motion_event mom_motion_type  mom_current_motion
 global mom_prev_pos mom_pos mom_nxt_mcs_goto
 global mom_pos_arc_center  mom_arc_angle
 global mom_nxt_pos_arc_center  mom_nxt_arc_direction  mom_nxt_arc_angle

proc VEC_angle_text { fl message } {
#=============================================================
  if {$fl!=0} { MOM_output_text "($message)" }
}
proc VEC_line_tan { p_begin  p_end  tan_vec  tp_angle } {
#=============================================================
 upvar $p_begin p1 ;  upvar $p_end p2  ;upvar $tan_vec v  ;
 if {$tp_angle==1} {
    VEC3_sub  p2 p1 v ; # v=p2-p1
   } else {
    VEC3_sub  p1 p2 v ; # v=p1-p2
  }
 return 0;
}

proc VEC_circular_tan { p_begin p_end p_center p_arc_angle tan_vec_cur tp_angle } {
#=============================================================
 upvar $p_begin p1 ; upvar $p_end p2 ; upvar $p_center pc  ; upvar $tan_vec_cur vt  ;
 VEC3_sub  p1 pc v1 ;
 VEC3_sub  p2 pc v2 ;
 VEC3_cross v1 v2 wt ;
 if {[EQ_is_gt $p_arc_angle 180.0]==1} {
        for {set ii 0} {$ii < 3} {incr ii} { set wt($ii) [expr ((-1.0) * $wt($ii))] }
 }
 if {$tp_angle==1} {   VEC3_cross wt v1 vt  } else {   VEC3_cross wt v2 vt  }
 return 0;
}

#=============================================================
proc VEC_angle_vec { v_tan1 v_tan2 } {
#=============================================================
 upvar $v_tan1 v1 ;  upvar $v_tan2 v2  ;
#
VEC_angle_text 0 "v1 =$v1(0) =$v1(1) =$v1(2)"
VEC_angle_text 0 "v2 =$v2(0) =$v2(1) =$v2(2)"
#
 set angle 0.0
 if {[VEC3_is_zero v1 ]} { return $angle }
 if {[VEC3_is_zero v2 ]} { return $angle }
 set len1 [ VEC3_mag v1 ] ;
 set len2 [ VEC3_mag v2 ] ;
 set scal [ VEC3_dot v1 v2 ] ;
 set RAD2DEG [expr 90.0 / asin(1.0)]  ; #multiplier to convert radians to degrees
 set tm [expr ($scal/($len1*$len2)) ]
 if {[EQ_is_ge $tm 1.0 ]}  { set tm 1.0 ; }
 if {[EQ_is_le $tm -1.0 ]}  { set tm -1.0 ; }
 VEC_angle_text 0 "cos(angle) =$tm"
 set angle [expr acos($tm) ]
 set angle [expr $RAD2DEG*$angle ]
 if {[EQ_is_zero $angle]} { set angle 0.0 ; }
 return $angle ;
}

# w = arccos((u,v)/(|u|*|v|)) Vector angle
#=============================================================
proc VEC_angle { t1 t2 t3 } {
#=============================================================
 upvar $t1 p1 ;  upvar $t2 p2  ;  upvar $t3 p3
 set tp_angle 2
 if {$tp_angle==1} {  VEC3_sub  p2 p1 v1 ;  } else {  VEC3_sub  p1 p2 v1 ;  }
 VEC3_sub  p3 p2 v2
#
VEC_angle_text 0 " v1 =$v1(0) =$v1(1) =$v1(2) \n v2 =$v2(0) =$v2(1) =$v2(2)"
#
 set angle 0.0
 if {[VEC3_is_zero v1 ]} { return $angle }
 if {[VEC3_is_zero v2 ]} { return $angle }
 set len1 [ VEC3_mag v1 ] ;
 set len2 [ VEC3_mag v2 ] ;
 set scal [ VEC3_dot v1 v2 ] ;
 set RAD2DEG [expr 90.0 / asin(1.0)]              ; #multiplier to convert radians to degrees
  set tm [expr ($scal/($len1*$len2)) ]
 if {[EQ_is_ge $tm 1.0 ]}  { set tm 1.0 ; }
 if {[EQ_is_le $tm -1.0 ]}  { set tm -1.0 ; }
 VEC_angle_text 0 "cos(angle) =$tm"
 set angle [expr acos($tm) ]
 set angle [expr $RAD2DEG*$angle ]
 if {[EQ_is_zero $angle]} { return 0.0 ; }
 return $angle ;
}

set angle 0.0

 if {[info exists mom_nxt_motion_event]} {

   VEC_angle_text $flag "mom_motion_event=$mom_motion_event ; mom_current_motion=$mom_current_motion ; mom_motion_type=$mom_motion_type ; mom_nxt_motion_event=$mom_nxt_motion_event"

   set angle [VEC_angle mom_prev_pos  mom_pos  mom_nxt_mcs_goto ] ;
   VEC_angle_text $flag "angle between points =$angle"

   if {$mom_current_motion=="linear_move"} {

     VEC_line_tan mom_prev_pos mom_pos vec1  1

     if {$mom_nxt_motion_event=="linear_move"} {
        VEC_line_tan mom_pos mom_nxt_mcs_goto vec2 1
        set angle [VEC_angle_vec vec1 vec2 ] ;
        VEC_angle_text $flag "angle between lines && lines=$angle"
      }

     if {$mom_nxt_motion_event=="circular_move"} {
        VEC_circular_tan mom_pos mom_nxt_mcs_goto mom_nxt_pos_arc_center $mom_nxt_arc_angle vec2 1
        set angle [VEC_angle_vec vec1 vec2 ] ;
        VEC_angle_text $flag "angle between lines && circular=$angle"
      }

     if {$mom_nxt_motion_event=="rapid_move"} {
        VEC_line_tan mom_pos mom_nxt_mcs_goto vec2  1
        set angle [VEC_angle_vec vec1 vec2 ] ;
        VEC_angle_text $flag "angle between lines && rapid =$angle"
      }

   }

   if {$mom_current_motion=="circular_move"} {
      VEC_circular_tan     mom_prev_pos    mom_pos   mom_pos_arc_center  $mom_arc_angle  vec1 2

     if {$mom_nxt_motion_event=="linear_move"} {
       VEC_line_tan mom_pos mom_nxt_mcs_goto vec2 1
       set angle [VEC_angle_vec vec1 vec2 ] ;
       VEC_angle_text $flag "angle between circular  &&  lines=$angle"
      }

     if {$mom_nxt_motion_event=="circular_move"} {
       VEC_circular_tan mom_pos mom_nxt_mcs_goto mom_nxt_pos_arc_center $mom_nxt_arc_angle vec2   1
       set angle [VEC_angle_vec vec1 vec2 ] ;
       VEC_angle_text $flag "angle between circular && circular=$angle"
      }

     if {$mom_nxt_motion_event=="rapid_move"} {
        VEC_line_tan mom_pos mom_nxt_mcs_goto vec2  1
        set angle [VEC_angle_vec vec1 vec2 ] ;
        VEC_angle_text $flag "angle between circular && rapid =$angle"
      }

   }

  }
 return $angle;
}

#=============================================================
proc VEC_feed_slowdn { max_feed angle modes } {
#=============================================================
 global  mom_warning_info

 global mom_kin_read_ahead_next_motion
 if {![info exists mom_kin_read_ahead_next_motion]} {
   set mom_warning_info "! \[proc VEC_feed_slowdn\]  mom_kin_read_ahead_next_motion=\"\" ! ( )"
   MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
   MOM_abort "$mom_warning_info"
 }

 set rt_value  0 ;

 global mom_nxt_feed_rate_mode  mom_nxt_feed_rate_output_mode  mom_next_feed_rate mom_nxt_feed_rate_per_rev

 global mom_programmed_feed_rate

 if {$modes==1} {
    if {[EQ_is_ge $mom_programmed_feed_rate $max_feed]} { set rt_value 1 ;}
  } else {

   global SLOWDN_ACCELERATION ;     # 
   set parameterC  0.0 ;            #    -   
   set DEG2RAD [expr asin(1.0) / 90.0]              ; #multiplier to convert degrees to radians

   set angle_radians [expr $DEG2RAD * $angle ] ; #    ( )
   ; # max_feed -    ( .)
   set FA [ expr  ($max_feed/(1.0-cos($angle_radians))) ] ; #   
   set FP $mom_programmed_feed_rate ; #  
   if {[EQ_is_lt $FA $FP ]} {
    set ss [expr ($FA*$FA-$FP*$FP)/(2.0 * $SLOWDN_ACCELERATION + parameterC) ] ; #   
    if {[EQ_is_lt $ss 0.0 ]} { set rt_value 1 ;}
    ; #   P ( ) ------ >  
    set rt_value 1 ;

   }

 }

return $rt_value ;
}
#=============================================================
proc PB_slowdn_move { } {
#=============================================================
# return : 1 - need slowdown ; 0 - not need
 global mom_modes_slowdn
 global mom_modes_slowdn_feed
 global mom_slowdn_angle ; #      
 global mom_slowdn_min_angle ; #   () -     
 global mom_slowdn_max_feed  ;

 set rt_value 0 ; #  

 if {[info exists mom_modes_slowdn]} {
    if {"$mom_modes_slowdn"=="ON" || "$mom_modes_slowdn"=="AUTO"} {
      set mom_slowdn_angle [ VEC_angle_calc ]
      if {$mom_slowdn_angle==""} { set rt_value 0 ; }
      #  Return true if s is greater than t
      if {[EQ_is_gt $mom_slowdn_angle $mom_slowdn_min_angle]} { set rt_value 1 ;}
    }
  }

 if {[info exists mom_modes_slowdn_feed]} {
   if {$mom_modes_slowdn_feed=="ON"} { set rt_value [VEC_feed_slowdn $mom_slowdn_max_feed $mom_slowdn_angle 1] ; }
 }

 return $rt_value
}

#=============================================================
proc MOM_slowdn { } {
#=============================================================
 global SLOWDN_MIN_ANGLE  SLOWDN_MAX_FEED  SLOWDN_ACCELERATION ; # 
 global mom_modes_slowdn_feed              ; #     ON/OFF
 global mom_modes_slowdn                   ; #   ON/OFF/AUTO
 global mom_slowdn_min_angle ; #   () -     
 global mom_slowdn_max_feed  ; #   
 global mom_kin_rapid_feed_rate  mom_kin_max_fpm
 global mom_warning_info

 if {"$mom_modes_slowdn"!="OFF"} {

 if {[info exists mom_slowdn_min_angle]} {
   if {"$mom_slowdn_min_angle"=="" || \
        [EQ_is_le $mom_slowdn_min_angle 0.0 ] || \
         [EQ_is_ge $mom_slowdn_min_angle 180.0 ] } {
    set mom_warning_info "! \[proc MOM_slowdn\]  mom_slowdn_min_angle=$mom_slowdn_min_angle ! (  - )"
    MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
    set mom_modes_slowdn  OFF ; set mom_slowdn_min_angle $SLOWDN_MIN_ANGLE ;
   }
  }

 }

 if {"$mom_modes_slowdn_feed"!="OFF"} {

  if {[info exists mom_slowdn_max_feed]} {
   if {"$mom_slowdn_max_feed"=="" || [EQ_is_le $mom_slowdn_max_feed 0.0 ] } {
    set mom_warning_info "! \[proc MOM_slowdn\]  mom_slowdn_min_angle=$mom_slowdn_min_angle ! (  - )"
    MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
    set mom_modes_slowdn_feed OFF ; set mom_slowdn_max_feed $SLOWDN_MAX_FEED ;
  }

  set err 0 ;
  if {"$mom_slowdn_max_feed"!=""} {
   #
   if {[info exists  mom_kin_rapid_feed_rate]} {
     if {$mom_slowdn_max_feed>=$mom_kin_rapid_feed_rate} { set mom_slowdn_max_feed $mom_kin_rapid_feed_rate ; }
     set err 1 ;
   }
   #
   if {[info exists  mom_kin_max_fpm]} {
     if {$mom_slowdn_max_feed>=$mom_kin_max_fpm} { set mom_slowdn_max_feed $mom_kin_max_fpm ; }
     set err 2 ;
   }
   #
   if {$err!=0} {
      set mom_warning_info "! \[proc MOM_slowdn\]    \n mom_kin_rapid_feed_rate=$mom_kin_rapid_feed_rate  !\n mom_kin_max_fpm=$mom_kin_max_fpm !\n mom_slowdn_max_feed=$mom_slowdn_max_feed !\n (  -  (err=$err))"
      MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
      set mom_modes_slowdn_feed OFF ; set mom_slowdn_max_feed $SLOWDN_MAX_FEED ;
   }
   #
  }

 }

}

 return 0

}


##########################################################################################
#=============================================================
proc MOM_start_of_thread { } { }
proc MOM_lathe_thread { } { }
proc  MOM_lathe_thread_move { } {
  global mom_lathe_thread_feed_rate
  global mom_lathe_thread_type mom_lathe_thread_advance_type
  global mom_lathe_thread_lead_i mom_lathe_thread_lead_k
  global mom_motion_distance
  global mom_lathe_thread_increment mom_lathe_thread_value
  global thread_type thread_increment feed_rate_mode

    switch $mom_lathe_thread_advance_type {
      1 {set thread_type CONSTANT ; }
      2 {set thread_type INCREASING ;}
      default {set thread_type DECREASING ; }
    }
        set LENGTH $mom_motion_distance
        set LEAD $mom_lathe_thread_value
        set INCR $mom_lathe_thread_increment
        set E [expr abs(pow(($LEAD + ($INCR * $LENGTH)) , 2) - pow($LEAD , 2)) / 2 *$LENGTH]

    if {$mom_lathe_thread_lead_i == 0} {
      MOM_suppress once I X ; MOM_force once K Z
    } elseif {$mom_lathe_thread_lead_k == 0} {
      MOM_suppress once K  Z; MOM_force once I X
    } else { MOM_force once I ; MOM_force once K ; }

global feed
if {$mom_lathe_thread_feed_rate==0} {
set mom_lathe_thread_feed_rate $feed
}
  global mom_pos mom_prev_pos  mom_lathe_thread_lead  mom_motion_distance
MOM_force Once  Z K X I
 if { $mom_pos(2)==$mom_prev_pos(2) } {
  MOM_suppress once Z K
 } else {
 if { $mom_pos(0)==$mom_prev_pos(0)} {
  MOM_suppress once X I
  } else {
    MOM_suppress once  I
    }
 }
  MOM_force Once G_thread
  MOM_do_template thread_move

}
proc MOM_end_of_thread { } { }
###############################
proc MOM_cycle_off { } {
global  mom_operation_type
if {$mom_operation_type=="Turn Centerline Drilling" } {
 MOM_drill_move;
 return;
 }
if {$mom_operation_type=="Turn Threading" } {
MOM_tap_move;
return;
 }

}

#--------------------------------------
proc MOM_tap { } {
  global cycle_name  cycle_init_flag
  set cycle_init_flag TRUE  ; set cycle_name TAP
  CYCLE_SET
}
proc  MOM_tap_move { } {
 global cycle_init_flag
 global mom_pos mom_prev_pos  mom_lathe_thread_lead  mom_motion_distance
MOM_force Once G_motion Z K X I
 if { $mom_pos(2)==$mom_prev_pos(2) } {
  MOM_suppress once Z K
 } else {
 if { $mom_pos(0)==$mom_prev_pos(0)} {
  MOM_suppress once X I
  } else {
 MOM_suppress once  I
   }
 }
global feed_tap feed  T_lathe_thread_lead
    if {$mom_lathe_thread_lead_i == 0} {
        set T_lathe_thread_lead  $mom_lathe_thread_lead_k
    } elseif {$mom_lathe_thread_lead_k == 0} {
       set T_lathe_thread_lead  $mom_lathe_thread_lead_i
    }

  MOM_do_template cycle_tap
  set cycle_init_flag FALSE
}
###############################
proc MOM_drill { } {
  global cycle_name
  global cycle_init_flag
  set cycle_init_flag TRUE
  set cycle_name DRILL
  CYCLE_SET
}

#============
proc  MOM_drill_move { } {
  global cycle_init_flag
global mom_cycle_step1 mom_cycle_feed_to_pos
set mom_cycle_step1 $mom_cycle_feed_to_pos(2)
global varR1 varR2
set varR1 100
set varR2 1000
  MOM_force Once L R1 R2 P Z
  MOM_do_template cycle_drill
  set cycle_init_flag FALSE
}

#============
proc MOM_drill_deep { } {
  global cycle_name
  global cycle_init_flag
  set cycle_init_flag TRUE
  set cycle_name DRILL_DEEP
  CYCLE_SET
}

#==============
proc  MOM_drill_deep_move { } {
  global cycle_init_flag
global varR1 varR2 mom_cycle_step1 mom_cycle_step2

set varR1 [expr $mom_cycle_step2/$mom_cycle_step1]
if {$varR1 == 0.000000} {
  set varR1 100
} else {
 set varR1 [expr $varR1*100]
}
set varR2 1000

  MOM_force Once L R1 R2 P Z
  MOM_do_template cycle_drill_deep
  set cycle_init_flag FALSE
}

#=============================================================


##########################################################################################
#=============================================================
proc MOM_check { } {
#=============================================================
global mom_max_X   mom_min_X   mom_max_Z   mom_min_Z
if {$mom_max_X>280.0} { set mom_max_X 280.0 }
if {$mom_min_X<0.0} { set mom_min_X 0.0 }
if {$mom_max_Z>300.0} { set mom_max_Z 300.0 }
if {$mom_min_Z<0.0} { set mom_min_Z 0.0 }
MOM_force once G
MOM_do_template check_block
}

#=============================================================
proc MOM_air { } {
#=============================================================
 global mom_air_spindle    mom_air_shablon
 if {[info exists mom_air_spindle]} {
   if {[info exists mom_air_shablon]} {
      if {$mom_air_spindle == "ON"} {
         if {$mom_air_shablon == "ON"} { return }
       }
   }
}

if {[info exists mom_air_spindle]} {
    if {$mom_air_spindle == "ON"} {   MOM_output_literal "M25"    }
    if {$mom_air_spindle == "OFF"} {  MOM_output_literal "M26"     }
    }

if {[info exists mom_air_shablon]} {
    if {$mom_air_shablon == "ON"} {  MOM_output_literal "M27"     }
   if {$mom_air_shablon == "OFF"} {  MOM_output_literal "M28"     }
    }

}

#=============================================================
proc MOM_spindle_orient_stop { } {
#=============================================================
 global  mom_spindle_orient_stop_flag
 if {[info exists mom_spindle_orient_stop_flag]} {
    if {$mom_spindle_orient_stop_flag == "ON"} {  MOM_output_literal "M19"     }
    }
}

#=============================================================
proc MOM_correction_speed { } {
#=============================================================
 global mom_corfeed     mom_corspeed    mom_corfeedspeed

 if {[info exists mom_corfeed]} { set fl1 1 ;  }
 if {[info exists mom_corspeed]} {  set fl2 1 ;  }
 if {[info exists mom_corfeedspeed]} {
      if {$mom_corfeedspeed == "ON"} {  MOM_output_literal "G22"; return ;  }
  }
if {[expr $fl1+$fl2] ==2} { MOM_output_literal "G22"; return;  }
if {$fl1==1 } {
    if {$mom_corfeed == "ON" }  {  MOM_output_literal "G20"; return;   }
 }
if {$fl2==1 } {
    if {$mom_corspeed == "ON"} { MOM_output_literal "G21"; return; }
   }

}

#=============================================================
proc MOM_correction_speed_off { } {
#=============================================================
 global mom_correction_speed
  if {[info exists  mom_correction_speed]} {
    if {$mom_correction_speed == "ON"} {   MOM_output_literal "G23"   }
    }
}

#=============================================================
proc MOM_transport { } {
#=============================================================
 global mom_transport_type
 if {[info exists  mom_transport_type]} {
    if {$mom_transport_type == "ON"} {   MOM_output_literal "M34"   }
    if {$mom_transport_type == "OFF"} {   MOM_output_literal "M35"   }
    }
}

#=============================================================
proc MOM_change_detail {} {
#=============================================================
 global mom_change_detail_number    mom_change_magazine
 if {[info exists  mom_change_detail_number]} {
      MOM_output_literal "M6$mom_change_detail_number"
    }
 if {[info exists  mom_change_magazine]} {
     if {$mom_change_magazine == "ON"}  {  MOM_output_literal "M68"  }
    }
}

#=============================================================
proc MOM_time_check { } {
#=============================================================
 global mom_time
 if {[info exists mom_time]} {
       if {"$mom_time" ==  "ON" } { set mom_time  ON ; return;}
  }
   set mom_time  OFF
}


############################################################################################################################

#***************************
# Source in user's tcl file.
#***************************
 set user_tcl_file ${cam_post_dir}atpu125_user.tcl
 if { [file exists $user_tcl_file] } {
    source $user_tcl_file
 }


